/*	
	This script created by sam.foster@frogdesign.com 
	February 09, 2001
 	Each line in the selection has a comment (// or #) prepended.
	Lines already commented are commented again - this allows an easy undo - without 
	removing needed code comments
	- The script attempts to guess which language from the extension
	Code indenting is preserved
*/

// global variables, constants
var app = Application;
var MB_OK = 0;

function Main () {

// abort if no text is selected
	if(!app.ActiveDocument.SelText) 
	{
		app.MessageBox("This will only run on a selection \n\naborting..","Comment Code",MB_OK);
		return false;
	}
	// this gives us an array of all the selected lines that we can loop over
	// thanks to Joel Muller for this block
	var intSelection = app.ActiveDocument.SelLength; 
	var strText = eval("app.ActiveDocument." + ((intSelection > 0) ? "SelText" : "Text"));
	var CrLf = String.fromCharCode(13) + String.fromCharCode(10);
	var arrLines = strText.split(CrLf);
	var tempVal;    

	var commentStr = getCommentType(app.ActiveDocument.Filename);
	// leave existing comments as-is. 
	var re = new RegExp("(^\\s*)(.*)");
	
	// now assemble the return string 
	retString = "";
	for(i=0;i<arrLines.length;i++)
	{
		
		re.test(arrLines[i]);
		retString += RegExp.$1 + commentStr + RegExp.$2;
		
		// add newline unless this is the last line in the selection
		if(i < arrLines.length-1) 
		{
			retString += "\n";
		}

	}

	// replace old with new in the document
	app.ActiveDocument.SelText = retString;

}

function getCommentType(filename) 
// matches and escapes '
{
	var ext = filename.substring(filename.lastIndexOf('.'));
	var commentType = "";
	if(ext == '.pl' || ext == '.pm' || ext == '.cgi') {
	 		commentType = "# ";
	}
	else if(app.ActiveDocument.Lines(0).charAt(0) == '#') {
	// if the first line looks like a shebang line
	 		commentType = "# ";
	}
	else if(ext == '.js' || ext == '.java') {
		// assume javascript / java / C sytax
	 		commentType = "// ";
	}
	else if(ext == '.asp' || ext == '.vbs') {
		// is vbscript
	 		commentType = "\' ";
	}
	/* 
		add extra rules in here...
	*/
	else {
		// assume javascript / java / C sytax as default
	 		commentType = "// ";
	}
	// app.activeDocument.Lines(0).char
	
	
	 return commentType;
}


// misc functions.. for debugging 
function alert(txt) {
	app.MessageBox(txt, "HomeSite: Comment Code",0);
}
