/*	
	This script created by sam.foster@frogdesign.com
	February 09, 2001
 	Each (commented) line in the selection has the comment character(s) removed
	
	- The script attempts to guess which language from the extension
	Code indenting is preserved
*/

// global variables, constants
var app = Application;
var MB_OK = 0;

function Main () {

// abort if no text is selected
	if(!app.ActiveDocument.SelText) 
	{
		app.MessageBox("This will only run on a selection \n\naborting..","Un-Comment Code",MB_OK);
		return false;
	}
	// this gives us an array of all the selected lines that we can loop over
	// thanks to Joel Muller for this block
	var intSelection = app.ActiveDocument.SelLength; 
	var strText = eval("app.ActiveDocument." + ((intSelection > 0) ? "SelText" : "Text"));
	var CrLf = String.fromCharCode(13) + String.fromCharCode(10);
	var arrLines = strText.split(CrLf);
	var tempVal;    

	var commentStr = getCommentType(app.ActiveDocument.Filename);
	// var commentStr = '//';
	var re = new RegExp("(^\\s*)" + commentStr + "(.*)");
	
	// now assemble the return string 
	retString = "";
	for(i=0;i<arrLines.length;i++)
	{

		// if line is commentted remove the first comment character(s)
		if(re.test(arrLines[i]))
		{
			retString += arrLines[i].replace(re, RegExp.$1 + RegExp.$2);
		}
		
		else 
		// the line isn't commented so leave it as is 
		{
			retString += arrLines[i];
		}

		// add newline unless this is the last line in the selection
		if(i < arrLines.length-1) 
		{
			retString += "\n";
		}

	}

	// replace old with new in the document
	app.ActiveDocument.SelText = retString;

}

function getCommentType(filename) 
// matches and escapes '
{
	var ext = filename.substring(filename.lastIndexOf('.'));
	var commentType = "";
	if(ext == '.pl' || ext == '.pm' || ext == '.cgi') {
	 		commentType = "# ";
	}
	else if(app.ActiveDocument.Lines(0).charAt(0) == '#') {
	// if the first line looks like a shebang line
	 		commentType = "# ";
	}
	else if(ext == '.js' || ext == '.java') {
		// assume javascript / java / C syntax
	 		commentType = "// ";
	}
	else if(ext == '.asp' || ext == '.vbs') {
		// is vbscript
	 		commentType = "\' ";
	}
	/* 
		add extra rules in here...
	*/
	else {
		// assume javascript / java / C syntax as default
	 		commentType = "// ";
	}
	
	 return commentType;
}

